Codeforces 1249E By Elevator or Stairs?【dp】


传送门:By Elevator or Stairs?


By Elevator or Stairs?

You are planning to buy an apartment in a n-floor building. The floors are numbered from 1 to n from the bottom to the top. At first for each floor you want to know the minimum total time to reach it from the first (the bottom) floor.

Let:

  • ai for all i from 1 to n−1 be the time required to go from the i-th floor to the (i+1)-th one (and from the (i+1)-th to the i-th as well) using the stairs;
  • bi for all i from 1 to n−1 be the time required to go from the i-th floor to the (i+1)-th one (and from the (i+1)-th to the i-th as well) using the elevator, also there is a value c — time overhead for elevator usage (you need to wait for it, the elevator doors are too slow!).

In one move, you can go from the floor you are staying at x to any floor y (x≠y) in two different ways:

If you are using the stairs, just sum up the corresponding values of ai. Formally, it will take ∑i=min(x,y)max(x,y)−1ai time units.
If you are using the elevator, just sum up c and the corresponding values of bi. Formally, it will take c+∑i=min(x,y)max(x,y)−1bi time units.
You can perform as many moves as you want (possibly zero).

So your task is for each i to determine the minimum total time it takes to reach the i-th floor from the 1-st (bottom) floor.

Input
The first line of the input contains two integers n and c (2≤n≤2⋅105,1≤c≤1000) — the number of floors in the building and the time overhead for the elevator rides.

The second line of the input contains n−1 integers a1,a2,…,an−1 (1≤ai≤1000), where ai is the time required to go from the i-th floor to the (i+1)-th one (and from the (i+1)-th to the i-th as well) using the stairs.

The third line of the input contains n−1 integers b1,b2,…,bn−1 (1≤bi≤1000), where bi is the time required to go from the i-th floor to the (i+1)-th one (and from the (i+1)-th to the i-th as well) using the elevator.

Output
Print n integers t1,t2,…,tn, where ti is the minimum total time to reach the i-th floor from the first floor if you can perform as many moves as you want.

Examples
input

10 2
7 6 18 6 16 18 1 17 17
6 9 3 10 9 1 10 1 5

output

0 7 13 18 24 35 36 37 40 45 

input

10 1
3 2 3 1 3 3 1 4 1
1 2 3 4 4 1 2 1 3

output

0 2 4 7 8 11 13 14 16 17 


题目大意:
问你从第 1 层到各个层的最少时间(1 ~ n);
上升有两种方式:走楼梯和坐电梯;
a i a_i ai 表示从第 i 层走到第 i+1 层的消耗时间
b i b_i bi 表示从第 i 层坐电梯到第 i+1 层的消耗时间

如果坐电梯的话,需要先等待 c 时间,然后才能坐电梯。但是坐电梯可以连续坐,也就是说如果连续坐,就只需要一次等待时间 c ,且上多个楼层。



解题思路:
一眼看出是个动规题,一开始想的是定义一个三维 dp,状态如下:

dp[i][2][2] :
	0 : 电梯
	1 : 楼梯
	dp[i][j][k]: 第 i 层 , 到达方式 j ,离开方式 k
	dp[i][0][0]:通过坐电梯到达第 i 层,且坐电梯离开
	dp[i][1][1]:通过走楼梯到达第 i 层,且走楼梯离开
	
	dp[i][0][0]=min(dp[i-1][0][0]+b[i-1],dp[i-1][1][0]+c+b[i-1])
	dp[i][1][0]=min(dp[i-1][0][1]+a[i-1],dp[i-1][1][1]+a[i-1])
	dp[i][0][1]=min(dp[i-1][0][0]+b[i-1],dp[i-1][1][0]+c+b[i-1])
	dp[i][1][1]=min(dp[i-1][0][1]+a[i-1],dp[i-1][1][1]+a[i-1])

列完状态转移之后就发现不需要判断的当前的走向,因为方程是一样的,所以就可以化简为一个二维 dp

	 dp[i][2]0 : 电梯
	 	1 : 楼梯
	 dp[i][0]:通过坐电梯到达第 i 层
	 dp[i][1]:通过走楼梯到达第 i 层
	 
	 dp[i][0]=min(dp[i-1][0]+b[i-1],dp[i-1][1]+c+b[i-1])
	 dp[i][1]=min(dp[i-1][0],dp[i-1][1])+a[i-1];




AC代码:

#include<iostream>
#include<algorithm>
#include<cstring>
#include<cstdio>
#include<cmath>
#define ll long long
#define inf 0x3f3f3f3f
using namespace std;
const int N=2e5+10;
int a[N],b[N];
int dp[N][2];
int n,c;

int main()
{
	scanf("%d%d",&n,&c);
	for(int i=1;i<n;i++)
	{
		scanf("%d",&a[i]);
	}
	for(int i=1;i<n;i++)
	{
		scanf("%d",&b[i]);
	}
	dp[1][0]=c;//开始就坐电梯需要加上等待时间 c
	dp[1][1]=0;
	for(int i=2;i<=n;i++)
	{
		dp[i][0]=min(dp[i-1][0]+b[i-1],dp[i-1][1]+c+b[i-1]);
		dp[i][1]=min(dp[i-1][0],dp[i-1][1])+a[i-1];
	}
	for(int i=1;i<=n;i++)
	{
		printf("%d%c",min(dp[i][0],dp[i][1]),i==n?'\n':' ');
	}
	return 0;
}

  • 1
    点赞
  • 2
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
区间DP是一种动态规划的方法,用于解决区间范围内的问题。在Codeforces竞赛中,区间DP经常被用于解决一些复杂的字符串或序列相关的问题。 在区间DP中,dp[i][j]表示第一个序列前i个元素和第二个序列前j个元素的最优解。具体的转移方程会根据具体的问题而变化,但是通常会涉及到比较两个序列的元素是否相等,然后根据不同的情况进行状态转移。 对于区间长度为1的情况,可以先进行初始化,然后再通过枚举区间长度和区间左端点,计算出dp[i][j]的值。 以下是一个示例代码,展示了如何使用区间DP来解决一个字符串匹配的问题: #include <cstdio> #include <cstring> #include <string> #include <iostream> #include <algorithm> using namespace std; const int maxn=510; const int inf=0x3f3f3f3f; int n,dp[maxn][maxn]; char s[maxn]; int main() { scanf("%d", &n); scanf("%s", s + 1); for(int i = 1; i <= n; i++) dp[i][i] = 1; for(int i = 1; i <= n; i++) { if(s[i] == s[i - 1]) dp[i][i - 1] = 1; else dp[i][i - 1] = 2; } for(int len = 3; len <= n; len++) { int r; for(int l = 1; l + len - 1 <= n; l++) { r = l + len - 1; dp[l][r] = inf; if(s[l] == s[r]) dp[l][r] = min(dp[l + 1][r], dp[l][r - 1]); else { for(int k = l; k <= r; k++) { dp[l][r] = min(dp[l][r], dp[l][k] + dp[k + 1][r]); } } } } printf("%d\n", dp[n]); return 0; } 希望这个例子能帮助你理解区间DP的基本思想和应用方法。如果你还有其他问题,请随时提问。
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值